import java.util.ArrayList;

import util.CollectionUtil;
import util.ExceptionHolder;
import util.SerialUtil;
import util.ThreadUtil;

/**
 * @author Heiner Kcker
 *
 */
public class TestClient
{

  /**
   * Constructor
   */
  public TestClient()
  {
    super();
    // TODO Auto-generated constructor stub
  }

  /**
   * Test
   * 
   * @param args
   */
  public static void main(
      String[] args )
  {
    for (int i = 0; i < 4000; i++ )
    {
      System.out.println( "i: " + i );
      final Thread thread = new Thread()
      {
        public void run()
        {
          testOneClient();    
        }
      };
      thread.start();
      ThreadUtil.sleepUnhandled( 1000 );
    }
    while (  1 == 1 );
  }

  /**
   * Test one
   */
  static void testOneClient()
  {
    final ProtocolClient protocolClient = new ProtocolClient( "localhost" , 30030 );
    for ( int i = 0 ; i < 10 ; i++)
    {
    final ArrayList<Object> paramList = SerialUtil.newArrList( 
        "a", 3, 30000, 66.66, true, false, null );
    paramList.add( SerialUtil.newArrList( 
        "a1", 33, 300030, 66.68, true, false, null ) );

System.out.println( "paramList: " + CollectionUtil.toStr( paramList ) );

    Object[] respValueArr = protocolClient.sendRequest(//--
        (short) 1 , //--
        new Object[] { paramList } , //--
        false );

    final ArrayList respList = (ArrayList) respValueArr[0];

System.out.println( "respList: " + CollectionUtil.toStr( respList ) );

    if ( !paramList.equals( respList ))
    {
      throw new RuntimeException();
    }
    ThreadUtil.sleepUnhandled( 60 * 1000 );
    
    final ExceptionHolder exceptionHolder = new ExceptionHolder( new RuntimeException( "xxx from client" ) );
    respValueArr = protocolClient.sendRequest(//--
        (short) 1 , //--
        new Object[] { exceptionHolder } , //--
        true );

    final ExceptionHolder respExceptionHolder = (ExceptionHolder) respValueArr[0];

System.out.println( "respExceptionHolder: " + respExceptionHolder );

    if ( !exceptionHolder.equals( respExceptionHolder ))
    {
      throw new RuntimeException();
    }
    ThreadUtil.sleepUnhandled( 60 * 1000 );
  }
    
    System.out.println( "ok" );
  }

}
