package crypt;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import util.Str8Buff;

/**
 * @author Heiner Kcker
 */
public class Test
{

  /**
   * Constructor
   */
  private Test()
  {
    super();
  }

  /**
   * Arbeitsverzeichnis
   */
  static final String userDirName = System.getProperty( "user.dir" );

  /**
   * Datei-Separator
   */
  static final String fileSeparatorStr = System.getProperty( "file.separator" );

  /**
   * Unterverzeichnis fr die generierten Klassen
   */
  static final String outDirStr = "dat";

  /**
   * Test
   * @param args
   * @throws IOException 
   */
  public static void main(
      String[] args )
      throws IOException
  {
    Str8Buff outByteBuff = new Str8Buff( 1024 );
    for (int i = 0; i < 2550000; i++ )
    //for (int i = 32; i < 126; i++ )
    {
      //strBuff.append( "" + i + "\n" );
      //final int baseByte = i;
      final int baseByte = (int) Math.round( Math.random() * 255 );

      outByteBuff.append( baseByte );
    }

    //String outStr = strBuff.toString();

    //outStr = "zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz";

    System.out.println( outByteBuff );

    final byte[] keyByteArr = "r1U2m3pelsTielzchen".getBytes();
    
    writeCrypt( outByteBuff.bytes(), keyByteArr );

    System.out.println();
    
    final byte[] readedByteArr = readCrypt(keyByteArr);

    System.out.println( new String( readedByteArr ) );

    if ( outByteBuff.length() != readedByteArr.length )
    {
      throw new RuntimeException();
    }
    
    for (int i = 0; i < outByteBuff.length(); i++ )
    {
      byte b = outByteBuff.byteAt( i );
      if ( b != readedByteArr[ i ] )
      {
        throw new RuntimeException( "i: " + i + " outByteBuff " + (int) b + " readedByteArr " + (int) readedByteArr[ i ] );
      }
    }
    System.out.println("ok");  
  }

  /**
   * @param pStr
   * @param pKeyByteArr
   * @throws IOException 
   */
  private static void writeCrypt(
      final byte[] pByteArr, 
      final byte[] pKeyByteArr )
      throws IOException
  {
    final File file = new File( //--
        userDirName
            + fileSeparatorStr + outDirStr + fileSeparatorStr + "test.dat" );

    if (file.exists())
    {
      file.delete();
    }

    final FileOutputStream fileOutputStream = new FileOutputStream( //--
        file );
    final CryptStream cryptStream = new CryptStream( //--
        fileOutputStream , //--
        pKeyByteArr );

    //final PrintWriter writer = new PrintWriter( cryptStream );
    //writer.append( pStrBuff );
    //writer.close();

    cryptStream.write( pByteArr );
    cryptStream.close();
  }

  /**
   * @param pKeyByteArr 
   * @param pStrBuff
   * @throws IOException 
   */
  private static byte[] readCrypt( //--
      final byte[] pKeyByteArr)
      throws IOException
  {
    final File file = new File( //--
        userDirName
            + fileSeparatorStr + outDirStr + fileSeparatorStr + "test.dat" );

    final FileInputStream fileInputStream = new FileInputStream( //--
        file );
    final EncryptStream encryptStream = new EncryptStream( //--
        fileInputStream , //--
        pKeyByteArr );

    final Str8Buff byteBuff = new Str8Buff( 1024 );
    int inByte;
    while (( inByte = encryptStream.read() ) != -1)
    {
      byteBuff.append( inByte );
    }
    encryptStream.close();

    return byteBuff.bytes();
  }
}
