package util;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * Methoden zum Umgang mit Exceptions . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class ExceptionUtil 
{
    /**
     * Konstruktor private, instanziieren verboten
     */
    private ExceptionUtil() {;}
    
    public static void printToErr(Throwable pThr)
    {
        System.err.println( pThr.getMessage() );
        pThr.printStackTrace();
    }
    
    /**
     * Zurckgeben des StackTrace einer Exception als String.
     *
     * @param tr zu bearbeitende Exception
     * @return StackTrace als String
     */
    public static String getStackTrace(
        final Throwable tr)
    {
      String  retString = "";

      if (tr != null)
      {
        StringWriter  writer = new StringWriter();
        PrintWriter   pwriter = new PrintWriter(writer);

        tr.printStackTrace(pwriter);

        retString = writer.toString();
      }

      return retString;
    } // end method getMessageAndStackTrace

   /**
    * Zurckgeben der Message und des StackTrace einer Exception als String
    *
    * @param tr zu bearbeitende Exception
    * @return Message und StackTrace als String
    */
   public static String getMessageAndStackTrace(
       final Throwable tr)
   {
     String  retString = "";

     if (tr != null)
     {
       retString = tr.getMessage();

       StringWriter  writer = new StringWriter();
       PrintWriter   pwriter = new PrintWriter(writer);

       tr.printStackTrace(pwriter);

       retString += "\n\n\nStacktrace:\n\n " + writer.toString();
     }

     return retString;
   } // end method getMessageAndStackTrace

}
