package util;

/**
 * @author Heiner Kcker
 */
public class InByteBuffer
{

  public final byte[] byteArr;

  public int pos = 0;

  /**
   * Constructor
   */
  public InByteBuffer(final byte[] pByteArr)
  {
    if (pByteArr == null
        || pByteArr.length < 1)
    {
      throw new IllegalArgumentException();
    }
    this.byteArr = pByteArr;
  }

  /**
   * get the current byte and
   * increment the position.
   * 
   * @return
   */
  public byte read()
  {
    return this.byteArr[this.pos++ ];
  }

  /**
   * get the specified count of bytes at
   * the current position and
   * increment the position.
   * 
   * @return
   */
  public byte[] read(
      final int pCount )
  {
    final byte[] retByteArr = new byte[pCount];
    for (int i = 0; i < pCount; i++ )
    {
      retByteArr[i] = this.byteArr[this.pos++ ];
    }
    return retByteArr;
  }

  /**
   * @param args
   */
  public static void main(
      String[] args )
  {
    // TODO Auto-generated method stub

  }

  /**
   * @return
   */
  public boolean empty()
  {
    return pos >= byteArr.length;
  }

}
