package util;

/**
 * Interface for Classes to transfer
 * over the Remote Client Server ProtocolClient.
 *
 * @author Heiner Kcker
 */
public interface RemotableInterface
{
  /**
   * Returns the unique number for
   * indentify the implementation class.
   *
   * Attention: ensure the uniqueness of the
   * class id manually or with an tool.
   *
   * TODO Tool to ensure the uniqueness
   *
   * @return class id number
   */
  public short getClassId();

  /**
   * Serialize the content of the
   * actualy object in an byte array.
   *
   * @return serialized data to transmit
   */
  public byte[] serialize();

  /**
   * Deserialze received data from given
   * {@link InByteBuffer} in the
   * actualy object.
   *
   * @param pInByteBuffer received serialized data
   */
  public void deserialize(
      InByteBuffer pInByteBuffer );
}
