package util;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.io.Reader;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;

/**
 * @author Marcin Brzoza (marcin@simpleworks.de)
 * @since Jul 17, 2005
 * @Author Jens Hohl
 * @since 27.7.2005
 */

public class StreamUtils
{
  public static final void close(InputStream _input)
  {
    if (_input != null)
    {
      try
      {
        _input.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  public static final void close(Reader _reader)
  {
    if (_reader != null)
    {
      try
      {
        _reader.close();
      }
      catch (Exception IGNORE)
      {

      }
    }
  }

  public static final void close(Selector _selector)
  {
    if (_selector != null)
    {
      try
      {
        _selector.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  public static final void close(SocketChannel _channel)
  {
    if (_channel != null)
    {

      try
      {
        _channel.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  public static final void close(OutputStream _output)
  {
    if (_output != null)
    {
      try
      {
        _output.flush();
      }
      catch (IOException IGNORE)
      {
      }

      try
      {
        _output.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  public static final void close(Socket _socket)
  {
    if (_socket != null)
    {
      try
      {
        _socket.close();
      }
      catch (Exception IGNORE)
      {
      }
    }
  }

  public static final void close(RandomAccessFile _randomAccessFile)
  {
    if (_randomAccessFile != null)
    {
      try
      {
        _randomAccessFile.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  /**
   * @param pServerSocket
   */
  public static void close(//--
      final ServerSocket pServerSocket)
  {
    if (pServerSocket != null)
    {
      try
      {
        pServerSocket.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

  /**
   * @param pServerSocketChannel
   */
  public static void close(
     final ServerSocketChannel pServerSocketChannel )
  {
    if (pServerSocketChannel != null)
    {
      try
      {
        pServerSocketChannel.close();
      }
      catch (IOException IGNORE)
      {
      }
    }
  }

}
