package util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

/**
 * Util class to compress data
 * an uncompress data.
 * 
 * @author Heiner Kcker
 */
public class GzipUtil
{

  /**
   * Constructor
   */
  public GzipUtil()
  {
    super();
    // TODO Auto-generated constructor stub
  }

  /**
   * compress data.
   * 
   * @param pByteArr
   * @return
   */
  public static byte[] gzip(
      final byte[] pByteArr )
  {
    try
    {
      final ByteArrayOutputStream byteArrOutstream = new ByteArrayOutputStream( pByteArr.length );
      final GZIPOutputStream gzipOutstream = new GZIPOutputStream( byteArrOutstream );
      gzipOutstream.write( pByteArr );
      gzipOutstream.close();
      return byteArrOutstream.toByteArray();
    }
    catch (IOException e)
    {
      // TODO log
      System.err.println( e.getMessage() );
      e.printStackTrace();

      throw new RuntimeException( e );
    }
  }

  /**
   * uncompress data.
   * 
   * @param pByteArr
   * @return
   */
  public static byte[] gunzip(
      final byte[] pByteArr )
  {
    try
    {
      final ByteArrayInputStream byteArrInstream = new ByteArrayInputStream( pByteArr );
      final GZIPInputStream gzipInstream = new GZIPInputStream( byteArrInstream );
      final Str8Buff buff = new Str8Buff( 1024 );
      int inByte;
      while (( inByte = gzipInstream.read() ) != -1)
      {
        buff.append( inByte );
      }
      return buff.bytes();
    }
    catch (IOException e)
    {
      // TODO log
      System.err.println( e.getMessage() );
      e.printStackTrace();

      throw new RuntimeException( e );
    }
  }

  /**
   * @param args
   */
  public static void main(
      String[] args )
  {
    if (true)
    {
      // test zip und unzip
      final byte[] testByteArr = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
          .getBytes();
      System.out.println( new String( testByteArr ) );
      final byte[] zipByteArr = GzipUtil.gzip( testByteArr );
      System.out.println( new String( zipByteArr ) );
      final byte[] unzipByteArr = GzipUtil.gunzip( zipByteArr );
      System.out.println( new String( unzipByteArr ) );
      if ( !Arrays.equals( testByteArr , unzipByteArr ))
      {
        throw new RuntimeException();
      }

    }
    System.out.println( "ok" );

  }

}
